<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – File System Layout</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="file-system-layout">File System Layout</h1>
<p>It is important that files are well placed and named within Cacti's directory structure. The naming structure may contain a <strong>category token</strong> and/or an <strong>action</strong>.</p>
<h2 id="token">Token</h2>
<p>Under each category directory, functions should be broken out into multiple files where applicable. All files must begin with the name of category (ie. its parent directory name). Valid token names are</p>
<ul>
<li>auth</li>
<li>automation</li>
<li>color_template</li>
<li>data_input</li>
<li>data_query</li>
<li>data_source</li>
<li>data_source_profile</li>
<li>data_template</li>
<li>device (rename from host)</li>
<li>device_template</li>
<li>event (if we have event management in core)</li>
<li>graph</li>
<li>graph_template</li>
<li>graph_tree</li>
<li>package</li>
<li>plugin</li>
<li>poller</li>
<li>preset (colors, cdefs, vdefs, gprints, etc)</li>
<li>site</li>
<li>user</li>
</ul>
<h2 id="actions">Actions</h2>
<p>This part should reflect what type of actions the file contains. Specific examples are listed below.</p>
<ul>
<li>info - reads information</li>
<li>update - writes (or changes) information</li>
<li>form - draws form-related information</li>
<li>execute - performs some action that does not modify or return information</li>
<li>utility - contains miscellaneous functions</li>
</ul>
<h2 id="function-verbs">Function Verbs</h2>
<p>Functions in those PHP modules shall name their token and shall contain a verb to explain the purpose. Specific examples are listed below.</p>
<ul>
<li>list</li>
<li>get</li>
<li>save</li>
<li>copy</li>
<li>clear</li>
<li>remove</li>
<li>update</li>
</ul>
<h2 id="directory-structure">Directory Structure</h2>
<h3 id="cli">cli/</h3>
<p><code>[token]_[action].php</code></p>
<h3 id="images">images/</h3>
<ul>
<li>icons/ # 16x16, 32x32 icons</li>
<li>buttons/ # button images (save, cancel, etc)</li>
<li>tabs/ # tab images</li>
</ul>
<h3 id="include">include/</h3>
<p>Code that must be accessed globally but is not contained inside of a function should be stored in the <code>include/</code> directory. The most common examples are to store globally accessible constants and arrays.</p>
<p>Directly under the <code>include/</code> directory, the files beginning with <code>global</code> are used to store information that is accessible everywhere in the code. Only store information in these files that are meaningful to the entire program. Also under the <code>include/</code> directory is a directory for each category (graph, device, etc), where information specific to that category is to be stored.</p>
<p>Constants that are made available everyone in the program</p>
<pre class="console"><code>include/global_constants.php
</code></pre>
<p>Arrays that are only used with graphs</p>
<pre class="console"><code>include/graph_arrays.php
</code></pre>
<pre class="console"><code>  content/
  fa/                                   # FontAwesome files
  js/                                   # javascript files
  themes/[theme]/                       # Visual theme files
  vendor/
    csrf/                               # CSRF Magic
    flag-icon-css/                      # Flag Icons
    phpgettext/                         # PHP GetText Library
    phpmailer/                          # PHP Mailer Library
    phpseclib/                          # PHP Security Library
    phpsnmp/                            # PHP Snmp Library
</code></pre>
<pre class="console"><code>  auth.php                              # Ensures user authenticate and
                                        # includes global.php
  cacti_version
  cli_check.php                         # Default Command Line Include also
                                        # includes global.php
  global_arrays.php
  global_constants.php                  # Constants only
  global_form.php                       # Form field definitions
  global_languages.php                  # Language selector
  global.php
  global_session.php                    # Session variable management
  global_settings.php                   # Setting definitions
  session.php                           # Session management

  plugins.php                           # Global plugin variables

  bottom_footer.php                     # Standard Footer
  top_general_header.php
  top_graph_header.php
  top_header.php

  layout.js                             # Main layout javascript
  realtime.js                           # Realtime javascript functions
</code></pre>
<h3 id="lib">lib/</h3>
<p>Functions that must be accessed globally should be stored in the ''lib/'' directory. This is where most of the heavy lifting in Cacti occurs.</p>
<p>Directly under the <code>lib/</code> directory, the files beginning with the <code>api</code> prefix are core Cacti API's that are only to be used by third party developers and should NEVER include a call to a <code>$_REQUEST</code>, <code>$_POST</code>, or <code>$_GET</code> variable.</p>
<p>Files that have the <code>html</code> prefix, generally invole the rendering of page content, for example the <code>html_form.php</code> library draws forms and <code>html_validate.php</code> includes functions to validate page variables there are other various files in the current cacti <code>lib/</code> directory that will over time be changing with the migration to the next major version of Cacti. So, these rules may change over time.</p>
<p>Here is the core API for the Cacti <code>graphs.php</code> page, and that deals with the manipulation of <strong>Graphs</strong>.</p>
<pre class="console"><code>lib/api_graph.php
</code></pre>
<h3 id="locales">locales/</h3>
<p>Language-related files are stored here to handle the multi-lingual natural of Cacti. These can be updated by running the <code>update-pot.sh</code> script. It is advised to do this whenever you are submitting a change to the Cacti via Pull Request. Otherwise, language translations can be missed.</p>
<h3 id="plugins">plugins/</h3>
<p>Directly under the <code>plugins/</code> directory are sub directories that contain plugins for Cacti. Since Cacti 1.0.0, all plugins must have an accompanying INFO file that details the plugin.</p>
<h2 id="including-and-requiring-files">Including and Requiring Files</h2>
<p>To reduce bloat, each file and/or function should include any and all files which it relies on.</p>
<p>The following function directly relies the libraries related to sequences and reading graph information. The <code>require_once</code> directive is used instead of <code>require</code> to prevent PHP re-declaration errors.</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">function</span> api_graph_item_save<span class="ot">(</span><span class="kw">$graph_item_id</span><span class="ot">,</span> &amp;<span class="kw">$_fields_graph_item</span><span class="ot">)</span> {</a>
<a class="sourceLine" id="cb6-2" title="2">    <span class="kw">require_once</span><span class="ot">(</span><span class="kw">CACTI_BASE_PATH</span> . <span class="st">&#39;/lib/sys/sequence.php&#39;</span><span class="ot">);</span></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="kw">require_once</span><span class="ot">(</span><span class="kw">CACTI_BASE_PATH</span> . <span class="st">&#39;/lib/graph/graph_info.php&#39;</span><span class="ot">);</span></a></code></pre></div>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
